/*
  CPP_NUM_CORES=8
  CPP_PROCESSES_PER_NODE=1
  CPP_PROBLEM=B
*/

/* RECORD
Universidad de Murcia
September 8, 2011
First Spanish Parallel Programming Contest, in situ
time 6386 ms
speed-up 2.68
*/

#ifdef DEBUG
#include <stdio.h>
#endif

#include <stdlib.h>

void copiar(int t,char *o,char *d)
{

  int i;

  for(i=0;i<t*t;i++)
    d[i]=o[i];
}

char valor(int t,char *a,int fila, int columna,int vecindad)
{
  int i,j,izq,der,sup;
  int cont=0,contuno=0;

#ifdef DEBUG
  printf("FILA y COLUMNA: %d %d: \n",fila,columna);
#endif
// Se cuenta el número de unos y de vecinos en filas anteriores, sin salir del tablero
  for(i=fila-1;i>=((fila-vecindad)>0?(fila-vecindad):0);i--)
  {
    izq=columna-vecindad+fila-i;
    izq=(izq>0?izq:0);
    der=columna+vecindad-fila+i;
    der=(der<(t-1)?der:(t-1));
    for(j=izq;j<=der;j++)
    {
      if(a[i*t+j]==1)
        contuno++;
      cont++;
    }
  }
#ifdef DEBUG
  printf("     unos en la parte anterior: %d \n",contuno);
#endif
// se acumula el número de unos y de vecinos en la misma fila, columnas anteriores, sin salir del tablero
  for(j=((columna-vecindad)>0?(columna-vecindad):0);j<columna;j++)
  {
    {
      if(a[fila*t+j]==1)
        contuno++;
      cont++;
    }
  }
#ifdef DEBUG 
  printf("     unos antes e izquierda: %d \n",contuno);
#endif
// se acumula el número de unos y de vecinos en la misma fila, columnas posteriores, sin salir del tablero
  der=((columna+vecindad)<(t-1)?(columna+vecindad):(t-1));
  for(j=columna+1;j<=der;j++)
  {
    {
      if(a[fila*t+j]==1)
        contuno++;
      cont++;
    }
  }
#ifdef DEBUG 
  printf("     unos arriba, izq y derecha: %d \n",contuno);
#endif
// se acumula el número de unos y de vecinos en filas posteriores, sin salir del tablero
  sup=((fila+vecindad)<(t-1)?(fila+vecindad):(t-1));
  for(i=fila+1;i<=sup;i++)
  {
    izq=columna+i-fila-vecindad;
    izq=(izq>0?izq:0);
    der=columna-i+fila+vecindad;
    der=(der<(t-1)?der:(t-1));
#ifdef DEBUG
    printf(" ( %d %d %d )\n",i,izq,der);
#endif
    for(j=izq;j<=der;j++)
    {
      if(a[i*t+j]==1)
        contuno++;
      cont++;
    }
  }
#ifdef DEBUG 
  printf("     unos arriba, izq, der y arriba: %d \n",contuno);
#endif
  if(2*contuno>=cont)
  {
#ifdef DEBUG
    printf("  unos, total, valor: %d %d 1\n",contuno,cont);
#endif
    return 1;
  }
  else
  {
#ifdef DEBUG
    printf("  unos, total, valor: %d %d 0\n",contuno,cont);
#endif
    return 0;
  }
}
  
void vida(int t,char *a,int vecmax,int iter,int nodo,int np)
{
  int niter,i,j;
  char *b,*temp;

  b=(char *) malloc(sizeof(char)*t*t); // Se utiliza como tablero temporal para escribir los resultados

// Se realizan las iteraciones
  for(niter=0;niter<iter;niter++)
  {
#pragma omp parallel for 
    for (i = 0; i < t; i++) 
    {
      for (j=0;j<t;j++)
      {
// Cada elemento se obtiene contando los unos en su vecindad,
// con tamaño de la vecindad determinado por la iteración y la vecindad máxima: 1, 2, ... ,vecmax , 1, 2 ...
        b[i*t+j]=valor(t,a,i,j,(niter%vecmax)+1);
      }
    }
// Se intercambian el tablero original y el temporal
    temp=a;
    a=b;
    b=temp;
  }
// Si el número de iteraciones es impar el resultado queda en el tablero temporal,
// por lo que se copia en el original
  if((iter%2)==1)
  {
    copiar(t,a,b);
    temp=a;
    a=b;
    b=temp;
  }

  free(b);
}
